//------------------------------------------/
//											/
//	Mikroprozessortechnik Praktikum 1		/
//	Aufgabe 2								/
//	Jrgen Dffinger 						/
//	Version 1.1				/
//	2010-04-08								/
//											/
//------------------------------------------/



// Deklarations for AT90S8515
.INCLUDE "8515def.inc"
.DEF temp = r16	//	working register

//	further definition follow here
.CSEG	//Program-Flash
rjmp start	//	Reset-address
.ORG 0x2A	//	dont program interrupt vector table



/****************   Initialisierung   ***************/

start:
	//	Stack initialisieren
	ldi R16,high(RAMEND)	//	Bits 8..15 laden 
	out sph,R16				//	obere Adresse des Stack initialisieren
	ldi R16,low(RAMEND)		//	Bits 0..7 laden
	out spl, R16			//	untere Adresse des Stack initialisieren
	
	//	Register initialisieren
	ldi R16,0x01			//	Register fr (nicht)setzen vorbereiten
	eor R10,R10				//	Register 10 auf 0 setzen

	//	PortC initialisieren
	in  R10, DDRC
	or  R10, R16
	out DDRC, R10



/***************   Hauptprogramm   ***************/

main:
	in R10, PORTC	//	PORTC sichern
	eor R10,R16		//	Zustand Bit0 ndern
	out PORTC, R10	//	PORTC beschreiben mit genderten Bit 0
	rcall counter	//	Zhler aufrufen fr 1s Wartezeit
	rjmp main



/***************   Zhler   ***************/

counter:
	//	Register sichern
	push R20
	push R21
	push R22

	//	Register initialisieren 
	ldi R20,0xA6	//	Bits 0..7
	ldi R21,0x13	//	Bits 8..15
	ldi R22,0x06	//	Bits 16..23
	loop:
		dec R20				//	Bits 0..7 dekrementieren
		brne loop			//	Prfen ob Bits 0..7 auf 0x00 stehen
		dec R21				//	Bits 8..15 dekrementieren
		brne loop			//	Prfen ob Bits 8..15 auf 0x00 stehen
		dec R22				//	Bits 16..23 dekrementieren
		brne loop			//	Prfen ob Bits 16..23 auf 0x00 stehen

	//	Register wiederherstellen
	pop R22
	pop R21
	pop R20
	nop
	nop
	ret					//	Rcksprung 




